<template>
  <div v-if="isMobile">
    <picker
      @cancel="closePicker(true)"
      @select="closePicker(false)"
      @change="pickerChanged"
      @valuechange="pickerValueChanged"
      ref="picker"
      :cancelTxt="$t('preorderDateSelector.cancel')"
      :confirmTxt="$t('preorderDateSelector.confirm')"
      :data="pickerData"
      :selectedIndex="pickerSelectedIndex"
      :title="$t('preorderDateSelector.title')"
      :value="false"
    />
  </div>
  <div v-else class="date-selector">
    <div class="section">
      <div class="section-title">{{ $t("preorderGroup.pickDate") }}</div>
      <tags
        class="date-list"
        @click="item => $emit('dateChanged', item.value)"
        :scroll="true"
        :value="dateTags"
        :fullwidth="true"
      />
    </div>
    <div class="section">
      <div class="section-title">{{ $t("preorderGroup.pickTime") }}</div>
      <tags
        class="time-list"
        @click="item => $emit('timeChanged', item.value)"
        :value="timeTags"
        tagWidth="16.666666%"
        tagMaxWidth="80px"
      />
    </div>
  </div>
</template>

<script>
import moment from "moment";
import { mapState } from "vuex";
import Tags from "@/components/Tags";
import Picker from "@/components/Picker";
import * as groupPresenter from "@/presenters/group";

export default {
  props: {
    date: [Date, String],
    time: String,
    dates: Array,
    times: Array
  },

  components: {
    Tags,
    Picker
  },

  data() {
    return {
      tmpDate: null,
      tmpTime: null,
      origDate: this.date,
      origTime: this.time
    };
  },

  watch: {
    times() {
      this.checkSelectedTime();
    },

    time() {
      this.checkSelectedTime();
    }
  },

  computed: {
    ...mapState(["isMobile"]),

    dateTags() {
      return this.dates.map(date => ({
        label: groupPresenter.formatDate(date),
        actived: moment(date).isSame(this.date, "day"),
        value: date
      }));
    },

    timeTags() {
      return this.times.map(time => ({
        label: time,
        actived: time === this.time,
        value: time
      }));
    },

    pickerSelectedIndex() {
      const timeIndex = this.times.indexOf(this.time);
      // 為了出現預設請選擇時間，this.date空字串導致picker沒辦法執行getTime
      // 改塞入空字串讓index直接為-1
      const dateIndex = this.dates.indexOf(
        this.date ? this.date.getTime() : ""
      );
      return [dateIndex, timeIndex];
    },

    pickerData() {
      const timeData = this.times.map(time => ({
        text: time,
        value: time
      }));
      const dateData = this.dates.map(date => ({
        text: groupPresenter.formatDate(date),
        value: date.getTime()
      }));
      return [dateData, timeData];
    }
  },

  methods: {
    pickerValueChanged(val, index) {
      const date = this.dates[index[0]];
      const time = this.times[index[1]];
      if (date !== this.date) {
        this.$emit("dateChanged", date);
      }
      if (time !== this.time) {
        this.$emit("timeChanged", time);
      }
    },

    pickerChanged(index, itemIndex) {
      if (index === 0) {
        const date = this.dates[itemIndex];
        this.tmpDate = date;
        this.$emit("dateChanged", date);
      } else {
        const time = this.times[itemIndex];
        this.tmpTime = time;
        this.$emit("timeChanged", time);
      }
    },

    closePicker(restore) {
      this.tmpDate = null;
      this.tmpTime = null;
      if (restore) {
        this.$emit("dateChanged", this.origDate);
        this.$emit("timeChanged", this.origTime);
      }
      setTimeout(() => {
        this.$emit("close");
      }, 300);
    },

    checkSelectedTime() {
      if (!~this.times.indexOf(this.time)) {
        this.$emit("timeChanged", "");
      }
    }
  },

  mounted() {
    this.$nextTick(() => {
      if (this.$refs.picker) {
        this.$refs.picker.show();
      }
      this.checkSelectedTime();
    });
  }
};
</script>

<style lang="scss" scoped>
.section {
  overflow: hidden;
}

.section-title {
  font-size: 14px;
  color: $color-secondary-black;
  margin-bottom: 10px;
}
</style>
